/*********************************************************************
* FILTER1.C - This program is a DOS filter that uses in-line         *
*   assembler to move characters from stdin to stdout.               *
*                                                                    *
* To compile: CL FILTER1.C                    Last revised: 10/18/91 *
*********************************************************************/

#define STDIN  0  /* Handle for stdin  - the standard input device  */
#define STDOUT 1  /* Handle for stdout - the standard output device */

/*********************************************************************
* main() - Main body of program                                      *
*********************************************************************/
void main( void )
    {
    static int InByte;
    int NumRead=1;
    int NumWrite;
    int ErrorCode=0;

    while ( NumRead && !ErrorCode )
        {
        /*----Read character from standard input device-------------*/
        NumRead = 0;
        ErrorCode = 0;
        _asm {
            MOV AH, 0x3f
            MOV BX, STDIN
            MOV CX, 1
            MOV DX, SEG InByte
            MOV DS, DX
            MOV DX, OFFSET InByte
            INT 0x21
            JC ERROR1
            MOV NumRead, AX
            JMP DONE1
ERROR1:     MOV ErrorCode, AX
DONE1:      }

        /*----Skip output if error or eof occurred------------------*/
        if ( NumRead && !ErrorCode)
            {
            /*----Write character to standard output device---------*/
            _asm {
                MOV NumWrite, 0
                MOV ErrorCode, 0
                MOV AH, 0x40
                MOV BX, STDOUT
                MOV CX, 1
                MOV DX, SEG InByte
                MOV DS, DX
                MOV DX, OFFSET InByte
                INT 0x21
                JC ERROR2
                MOV NumWrite, AX
                JMP DONE2
ERROR2:         MOV ErrorCode, AX
DONE2:          }
            }
        } /* end while loop */
    }
