/*********************************************************************
* MCB.H - Definitions, prototypes, and macros for handling MCBs.     *
*********************************************************************/
#define mcbRSRVD    11         /* Size of MCB reserved area         */
#define mcbSIZE     16         /* Size of a DOS MCB structure       */

union REGS regs;               /* Registers for intdos() calls      */
struct SREGS sregs;            /* Segment regs. for intdosx() calls */

#pragma pack(1)                /* MCB structure must be packed      */
typedef struct tag_MCB
    {
    char            marker;              /* Chain status marker     */
    unsigned int    owner;               /* Owner of block (PSP)    */
    unsigned int    size;                /* Size of block (para)    */
    unsigned char   reserved[mcbRSRVD];  /* 3 reserved bytes + name */
    } MCB;

/*----Function prototypes of getFirstMCB() and getNextMCB()---------*/
MCB far *getFirstMCB( void );            /* Get addr of first MCB   */
MCB far *getNextMCB( MCB far * );        /* Get addr of next MCB    */

/*----Macros for getting segment:offset of any data item------------*/
#define GET_SEG(a) ( (unsigned)((long)(void _far *)(a)>>16) )
#define GET_OFF(a) ( (unsigned)((void _near *)(a)) )

/*----Macro for building far pointer from segment & offset values---*/
#define MK_FP(s,o) ( (void far *)( (long)s<<16 | o) )

